#include "Net.h"


#define MAX_AA	21

#define Nout            G_N[G_nl]    /* . Numero dei nodi dell' OUTPUT layer */
#define Nin             G_N[0]   /* ... Numero dei nodi dell'INPUT layer ...*/
#define xout            G_o[G_nl] /* ... associate xout to the output layer */
#define xin             G_o[0]   /*.. associate xin to the input layer */
#define Ncl		2
#define	Classes		0


typedef struct {
      int m[Ncl][Ncl];
}ACCTAB;

int Lset;
int Dimcod=21;
int Win=24;
int Diminp;
int Diminpout;

int **Inp;
char Amino[]="ACDEFGHIKLMNPQRSTVWYX";

ACCTAB  AccInd[Classes+1];

/*-------functions ----*/
int ** readfile(char *, int *, int);
int is_aa(char);
int makeinp(int);
void testacc(void);
void computacc(void);
/*-------functions ----*/

main(int argc, char * argv[])
{
   int i,j,k; 
   int learncyc=0;
   double usqm;
 
   Diminp=Dimcod*Win; 
   Diminpout=Diminp;/*anche l'uscita*/

   if(argc == 1) { 
      printf ("usage %s inputfile [learningCycles]\n",argv[0]); 
      exit(-1);
   }
   printf(" InputFile = %s\n", argv[1]);
   Inp=(int **)readfile(argv[1],&Lset,Diminpout); /*setta l'input */

   G_initialize();
   G_readw();
   
   if(argc ==3) {
      learncyc=atoi(argv[2]);
   } else {
      printf("number of learning cycles = ");
      scanf("%d",&learncyc);
   }
   printf(" Learnin Cycles = %d\n",learncyc); 
   for(j=0; j < learncyc; j++) {
      usqm = 0;	   
      for(i=0; i < Lset; i++) {
         makeinp(i);
         usqm += G_stepf();

         G_gbp();
         G_updatew();
/*         printf("%f\n",(float)usqm);*/
      } 
#ifdef PRINTSQM
       printf(" SQ cycle %d pattern %d = %f\n",j,i,usqm);
#endif
      G_writew();
   }   

   testacc();
   computacc(); 
   return;
   
}
/*==================================*/



/*------------------------------------ 
--------------------------------------
---------------------------------------*/
void computacc()
{
   double p[Ncl], n[Ncl], u[Ncl], o[Ncl];
   double P, N,t;
   int i,j,k,c;
     



	
   printf ("\nANALISI SEQUENZA TOTALE\n");
   for(c=0; c <= Classes; c++) {
       i=1 ;
         for(j=0; j< Ncl; j++) {
	    if (j==0){printf ("Potenziali siti di taglio\t"); 
            printf("%d\n",AccInd[c].m[i][j]);
  	       }
	}
      
/**/
     
/**/
   }
}
/*------------------------------------ 
--------------------------------------
---------------------------------------*/


/*------------------------------------ 
--------------------------------------
---------------------------------------*/
void testacc() 
{
   int i,j,k,a;
printf ("ANALISI SINGOLA POSIZIONE\n");
   for(k=0; k <= Classes; k++) {
      for(i=0; i< Ncl; i++) {
         for(j=0; j< Ncl; j++) {
            AccInd[k].m[i][j]=0;
         }
      }
   }

   for(i=0; i < Lset; i++) {
	a=i+1;
	makeinp(i);
      G_stepf();
   for(k=0; k<Nout; k++) 
     { printf("%.4f\t",xout[k]);
      printf ("\t");
    }

   for(k=0; k < Classes; k++) {
         if(Inp[i][Win*Dimcod+k]) {
           k++;
           break;
         }
      } 

      if(G_od[0]) {
         if(xout[0]> 0.5) { 
            AccInd[0].m[0][0]++;
//`            AccInd[k].m[0][0]++;
         }
         else {
            AccInd[0].m[0][1]++;
//            AccInd[k].m[0][1]++;
         }
      }else {
         if(xout[0]> 0.5) {             
            AccInd[0].m[1][0]++;
//            AccInd[k].m[1][0]++;
         }
         else {
            AccInd[0].m[1][1]++;
//            AccInd[k].m[1][1]++;
         }
      }

   } 

}
/*------------------------------------ 
--------------------------------------
---------------------------------------*/



/*------------------------------------ 
--------------------------------------
---------------------------------------*/
int makeinp(int ind)
{
   int i;

   for(i=0; i < Diminp; i++) {
      xin[i]=(double) Inp[ind][i];
   }

   G_od[0]=(double) Inp[ind][Diminpout];

   return(0); 
}
/*------------------------------------ 
--------------------------------------
---------------------------------------*/


/*------------------------------------ 
--------------------------------------
---------------------------------------*/
int ** readfile (char * name,int *Lset, int Diminpout)

{
   FILE *fp;
   int i,j;
   char s[51];
   int **pi;

   if((fp=fopen(name,"rt"))==NULL) {
      printf("Can't open %s\n",name);
      exit(-1);
   }
   else {
      fscanf(fp,"%d",Lset);
      if( (pi=(int **) malloc(sizeof(int*)*(*Lset)))==NULL) {
         printf("Can't allocate memory\n"); exit(-1);
      }
      for(i=0; i < *Lset; i++) {
         if( (pi[i]=(int *) malloc(sizeof(int)*Diminpout))==NULL) {
            printf("Can't allocate memory: %i\n",i); exit(-1);
         }
      }   
      for(i=0; i < *Lset; i++) {
          for(j=0; j < Diminpout; j++) {
              fscanf(fp,"%d",&pi[i][j]);
          }
      }
   }
   return(pi);
}
/*------------------------------------ 
--------------------------------------
---------------------------------------*/
          

/*------------------------------------ 
--------------------------------------
---------------------------------------*/
int is_aa(char c)
{
   int i;

   for(i=0; i < MAX_AA; i++) {
      if(c==Amino[i]) {
         return(i);
      }
   }
   printf("not a Residue\n");
   exit(-1);
}
/*------------------------------------ 
--------------------------------------
---------------------------------------*/

